from thingz import touch_n
from thingz import touch_s
from thingz import button_b
from thingz import button_a

import time
import ssl
import socketpool
import wifi
import adafruit_minimqtt.adafruit_minimqtt as MQTT
import random

# BacPro MSPC
# Introduction à la mise en œuvre des systèmes communicants
# TP n°5
# découverte de l'utilisation du protocole MQTT
# Utilisation du capteur d'humidité
# Utilisation avec un Broker local comme Mosquitto
# version du 04/11/2022

# Ne pas modifier, inutilisé
clientid="a"

# Renseigner les données du point d'accès Wifi
SSID="SFR_B5F8"
mot_passe_SSID="45cdmi6ygm24wdrd5nxa"
adresse_ip_broker_mosquitto="192.168.1.29"

# topic utilisé pour la publication d'un lessage au Broker
photocell_feed = "air/humidite"

### Code ###
def display_clear():
    print('[2J', end='')
    
def connected(client, userdata, flags, rc):
    # Utilisée lorsque que le client est connecté au Broker
    # Le client s'inscrit au topic du Broker.
    client.subscribe(photocell_feed)
    print("Connecté au Mosquitto serveur PC ")

def disconnected(client, userdata, rc):
    # Si déconnexion du client
    print("Déconnecté du broker!")

def message(client, topic, message):
    # envoi de la donnée au topic
    print("Nouveau message avec le topic {0}: {1}".format(topic, message))

def menu_gene():
    global choix_menu
    print('Menu capteur connecté')
    print('1. Scan SSID')
    print('2. Connexion SSID')
    print('3. Adresse IP')
    print('4. Valeurs humidite')
    print('5. Lancer la publication')
    print('Choix avec bouton B')
    print(''.join([str(x4) for x4 in ['Choix=', choix_menu, '']]))
    
def menu():
    global choix_menu
    if touch_n.was_touched():
        if choix_menu <= 4:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + 1
            menu_gene()
    if touch_s.was_touched():
        if choix_menu > 1:
            choix_menu = (choix_menu if isinstance(choix_menu, int or float) else 0) + -1
            menu_gene()
    if button_b.was_pressed():
        if choix_menu == 1:
            display_clear()
            print('Liste SSID WIFI')
	    nb_ssid=0
	    for network in wifi.radio.start_scanning_networks():
               print('SSID=', network.ssid, ' RSSI=', network.rssi)
               nb_ssid +=1
            wifi.radio.stop_scanning_networks()
            print('Appuyer bouton A')
            while not(button_a.was_pressed()):
                pass
            menu_gene()
	else:
            if choix_menu == 2:
                display_clear()
                print("Connexion du")
                print("capteur d humidite")
                print("sur le réseau ...")
                try:
                    wifi.radio.connect(SSID, mot_passe_SSID)
                    print("Connecté au réseau")
                    print('Appuyer bouton A')
                    while not(button_a.was_pressed()):
                        pass
                    menu_gene()
                except:
                    print("Impossible de connecter")
                    print("au réseau!")
                    print("Revoir le paramétrage")
            else:
                if choix_menu == 3:
                    display_clear()
                    print('Adresse IP='+str(wifi.radio.ipv4_address))
                    print('Appuyer bouton A')
                    while not(button_a.was_pressed()):
                        pass
                    menu_gene()
                else:
                    if choix_menu == 4:
                        display_clear()
                        print("Visualisation donnees")
                        print("capteur humidité")
                        print('Appuyer bouton A')
                        print('pour revenir au menu')
                        time.sleep(5)
                        while not(button_a.was_pressed()):
                            print('Val capt H%='+str(random.randrange(0,100,1)))
                            time.sleep(1)
                        menu_gene()              
                    else:
                        demarrage()

def demarrage():
    # Création d'un pool de sockets
    pool = socketpool.SocketPool(wifi.radio)

    # Définition du client MQTT pour inscription au Broker
    mqtt_client = MQTT.MQTT(
        broker=adresse_ip_broker_mosquitto,
        port=1883,
        username="a",
        password=clientid,
        socket_pool=pool,
        ssl_context=ssl.create_default_context(),
    )

    # Mise en place des méthodes pour la gestion du protocole MQTT
    mqtt_client.on_connect = connected
    mqtt_client.on_disconnect = disconnected
    mqtt_client.on_message = message

    # Connexion du client au Broker MQTT.
    print("Connexion au Broker")
    print("Mosquitto serveur PC...")
    
    mqtt_client.connect()

    while True:
        # Interrogation de file d'attente des messages
        mqtt_client.loop()
        humidite=random.randrange(0,100,1)
        # envoi du nouveau message
        print("Envoi de la donnée: %d..." % humidite)
        mqtt_client.publish(photocell_feed, humidite)
        print("Envoyée!")
        time.sleep(5)
        
display_clear()
print("TP5 mspc")
print("Capteur humidite")
time.sleep(5)
choix_menu = 1
menu_gene()
while True:
    menu()